package com.jiuqi.sql;

import java.io.IOException;
import java.io.Reader;

public abstract class SQLScriptExcutor {
   private Reader reader;
   private boolean isIgnoreComment;
   private boolean isString;
   private boolean isBlockComment;
   private boolean isLineComment;
   private StringBuffer sql;
   private StringBuffer line;

   public SQLScriptExcutor(Reader sqlReader, boolean isIgnoreComment) {
      this.reader = sqlReader;
      this.isIgnoreComment = isIgnoreComment;
      this.sql = new StringBuffer();
      this.line = new StringBuffer();
   }

   public final void parse() throws IOException, DBException {
      int i;
      while((i = this.reader.read()) != -1) {
         char c = (char)i;
         if (c != '\r' && c != '\n') {
            if (!this.isLineComment) {
               if (this.isBlockComment && this.isIgnoreComment) {
                  if (c == '*') {
                     i = this.reader.read();
                     c = (char)i;
                     if (c != -1 && c == '/') {
                        this.isBlockComment = false;
                     }
                  }
               } else {
                  char nextChar;
                  switch (c) {
                     case '\'':
                        this.line.append(c);
                        if (!this.isBlockComment) {
                           this.isString = !this.isString;
                        }
                        break;
                     case '*':
                        if (this.isBlockComment) {
                           c = (char)this.reader.read();
                           if (c == -1) {
                              break;
                           }

                           if (c == '/') {
                              this.isBlockComment = false;
                           }

                           if (!this.isIgnoreComment) {
                              this.line.append('*').append(c);
                           }
                           break;
                        }

                        this.line.append('*');
                        break;
                     case '-':
                        if (!this.isBlockComment && !this.isString) {
                           i = this.reader.read();
                           c = (char)i;
                           if (c == '-') {
                              this.isLineComment = true;
                              break;
                           }

                           this.line.append('-').append(c);
                           break;
                        }

                        this.line.append('-');
                        break;
                     case '/':
                        if (!this.isBlockComment && !this.isString) {
                           i = this.reader.read();
                           c = (char)i;
                           if (i == -1) {
                              break;
                           }

                           if (c == '*') {
                              this.isBlockComment = true;
                              if (!this.isIgnoreComment) {
                                 this.line.append('/').append(c);
                              }
                              break;
                           }

                           this.line.append('/').append(c);
                           break;
                        }

                        this.line.append('/');
                        break;
                     case ';':
                        if (!this.isBlockComment && !this.isString) {
                           this.excute();
                           break;
                        }

                        this.line.append(';');
                        break;
                     case 'G':
                        if (!this.isBlockComment && !this.isString) {
                           i = this.reader.read();
                           c = (char)i;
                           if (c != 'O' && c != 'o') {
                              this.line.append('G').append(c);
                              break;
                           }

                           i = this.reader.read();
                           nextChar = (char)i;
                           if (nextChar != '\r' && nextChar != '\n') {
                              this.line.append('G').append(c).append(nextChar);
                              break;
                           }

                           this.excute();
                           break;
                        }

                        this.line.append('G');
                        break;
                     case 'g':
                        if (!this.isBlockComment && !this.isString) {
                           i = this.reader.read();
                           c = (char)i;
                           if (c != 'O' && c != 'o') {
                              this.line.append('g').append(c);
                              break;
                           }

                           i = this.reader.read();
                           nextChar = (char)i;
                           if (nextChar != '\r' && nextChar != '\n') {
                              this.line.append('g').append(c).append(nextChar);
                              break;
                           }

                           this.excute();
                           break;
                        }

                        this.line.append('g');
                        break;
                     default:
                        this.line.append(c);
                  }
               }
            }
         } else {
            if (this.line.length() != 0) {
               this.sql.append(this.line.toString());
               this.sql.append("\r\n");
               this.line.setLength(0);
            }

            this.isLineComment = false;
         }
      }

      this.excute();
   }

   public boolean isIgnoreComment() {
      return this.isIgnoreComment;
   }

   private void excute() throws DBException {
      this.sql.append(this.line.toString());
      if (this.sql.length() != 0) {
         this.excuteSingleSql(this.sql.toString());
      }

      this.line.setLength(0);
      this.sql.setLength(0);
   }

   protected abstract void excuteSingleSql(String var1) throws DBException;
}
